VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="public"

# Build the site
build:
    ARG yama_env="production"

    FROM klakegg/hugo:alpine
    #FROM klakegg/hugo:ext-alpine # If you need additional tools (nodejs, yarn, go, babel...) https://github.com/klakegg/docker-hugo#hugo-extended-edition

    COPY . .

    ENV HUGO_ENV=production
    ENV YAMA_ENV=$yama_env

    #RUN npm ci
    RUN hugo --destination="$build_dir"

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir

##################
# Helper targets #
##################

# Run the `hugo server` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=1313
    ARG container_name="earthly-dev-server"

    LOCALLY
        WITH DOCKER
            # https://hub.docker.com/r/klakegg/hugo
            RUN docker run --rm \
                           --volume="$PWD:/src" \
                           --publish $port:1313 \
                           --name="$container_name" \
                           klakegg/hugo:alpine \
                           server
	END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop "$container_name"


################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
